"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var readline_1 = __importDefault(require("readline"));
var fs_extra_1 = __importDefault(require("fs-extra"));
var stream_1 = require("stream");
var utils_1 = require("./utils");
var defaultConfig = {
    keys: {
        id: "id",
        parentId: "parentId",
        children: "children",
        data: "data"
    },
    tab: {
        insertSpaces: false,
        size: 4,
        autoDetect: true
    },
    getId: function (data) { return data; }
};
var getConfig = function (config) {
    if (config === void 0) { config = {}; }
    return __assign(__assign({}, defaultConfig), config);
};
var getRegExp = function (config) {
    var _a = config.tab, insertSpaces = _a.insertSpaces, size = _a.size;
    return insertSpaces ? new RegExp(" {" + size + "}", "g") : new RegExp("\t", "g");
};
var createNode = function (data, parent, config) {
    if (parent === void 0) { parent = null; }
    if (config === void 0) { config = {}; }
    var _a = getConfig(config), getId = _a.getId, keys = _a.keys;
    var treeNode = {
        data: data,
        id: getId(data),
        parentId: parent ? parent.id : null,
        children: []
    };
    if (parent)
        parent.children = __spreadArrays(parent.children, [treeNode]);
    return utils_1.renameObjKeys(treeNode, keys);
};
exports.parseStream = function (stream, config) {
    if (config === void 0) { config = {}; }
    return __awaiter(void 0, void 0, void 0, function () {
        var original, _config, clone, rl_2, rl_1, rl_1_1, line, e_1_1, rl, re;
        var e_1, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    original = stream.pipe(new stream_1.PassThrough());
                    _config = getConfig(config);
                    if (!_config.tab.autoDetect) return [3 /*break*/, 12];
                    clone = stream.pipe(new stream_1.PassThrough());
                    rl_2 = readline_1.default.createInterface({ input: clone });
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 6, 7, 12]);
                    rl_1 = __asyncValues(rl_2);
                    _b.label = 2;
                case 2: return [4 /*yield*/, rl_1.next()];
                case 3:
                    if (!(rl_1_1 = _b.sent(), !rl_1_1.done)) return [3 /*break*/, 5];
                    line = rl_1_1.value;
                    if (line.search(" ") >= 0) {
                        _config.tab.insertSpaces = true;
                        _config.tab.size = line.search(/\S/);
                        return [3 /*break*/, 5];
                    }
                    if (line.search("\t") >= 0) {
                        _config.tab.insertSpaces = false;
                        return [3 /*break*/, 5];
                    }
                    _b.label = 4;
                case 4: return [3 /*break*/, 2];
                case 5: return [3 /*break*/, 12];
                case 6:
                    e_1_1 = _b.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 12];
                case 7:
                    _b.trys.push([7, , 10, 11]);
                    if (!(rl_1_1 && !rl_1_1.done && (_a = rl_1.return))) return [3 /*break*/, 9];
                    return [4 /*yield*/, _a.call(rl_1)];
                case 8:
                    _b.sent();
                    _b.label = 9;
                case 9: return [3 /*break*/, 11];
                case 10:
                    if (e_1) throw e_1.error;
                    return [7 /*endfinally*/];
                case 11: return [7 /*endfinally*/];
                case 12:
                    rl = readline_1.default.createInterface({ input: original });
                    re = getRegExp(_config);
                    return [2 /*return*/, new Promise(function (resolve, _reject) {
                            var roots = [];
                            var parents = {};
                            rl.on("line", function (line) {
                                var match = line.match(re);
                                var depth = !match ? 0 : match.length;
                                var trimmedLine = line.trim();
                                var parent = depth === 0 ? null : parents[depth - 1];
                                var treeNode = createNode(trimmedLine, parent, _config);
                                if (depth === 0) {
                                    roots.push(treeNode);
                                }
                                parents[depth] = treeNode;
                            });
                            rl.on("close", function () {
                                return resolve(roots);
                            });
                        })];
            }
        });
    });
};
exports.parseFile = function (filePath, config) {
    if (config === void 0) { config = {}; }
    return exports.parseStream(fs_extra_1.default.createReadStream(filePath), config);
};
//# sourceMappingURL=index.js.map